/*************************************************
 * Zeus CMD - C++ Tutorial 6 : Advanced Output   *
 * By Grant James (ZEUS)                         *
 * http://www.zeuscmd.com                        *
 *************************************************/
#include <stdio.h>
#include <iostream>
#include <iomanip>
#include <stdlib.h>

using namespace std;

int main()
{
	/**********************************************************/
	// Variable Declarations
	/**********************************************************/
	char c = 'a';
	short s = 56;
	int i = 4500;
	long l = 500000;
	float f = 45.34f;
	double d = 233423.2362;
	
	/**********************************************************/
	// C Output
	/**********************************************************/
	printf("C Output\n-------------------------\n");
	// Characters / Strings
	printf("Character 1 : %c Character 2 : %c\n", c, 't');
	printf("String : %s\n", "Hello");

	// Numbers
	printf("Short : %d\n", s);
	printf("Integer : %d\n", i);
	printf("Long : %d\n", l);

	// Floating point Numbers
	printf("Float : %f\n", f);
	printf("Double : %f\n", d);

	// Number formatting
	printf("Float with 2 Decimal digits : %.2f\n", d);
	printf("Decimal : %d, Hex : %X, Octal : %o\n", i, i, i);
	printf("Unsigned number : %u\n", -500);
	
	// Character Formatting
	printf("Hello%4cHello%10cHello%7s\n",'\0','\0',"String");
	
	printf("\n");
	
	/**********************************************************/
	// C++ Output
	/**********************************************************/
	cout << "C++ Output" << endl << "------------------------------" << endl;
	// Width of Display Field
	cout << setw(20) << "Block 1" << setw(10) << "Block 2" << endl;
	cout.setf(ios::left);
	cout << setw(20) << "Block 1" << setw(10) << "Block 2" << endl;
	cout.unsetf(ios::left);
	cout << setw(20) << "Block 1" << setw(10) << "Block 2" << endl;

	// Fill
	cout << setw(20) << setfill('#') << "Block 1" << setw(10) << "Block 2" << endl;
	
	// Precision
	cout.setf(ios::fixed);
	cout << setprecision(2) << d << endl;
	
	printf("\n");
	
	/**********************************************************/
	// Escape Characters
	/**********************************************************/
	printf("Escape Characters\n---------------------------");
	printf("\tTabbed text\n"); // tab
	printf("Alarm\a\n"); // alarm
	printf("Quotes : \"Hello\"\n");

	system("sleep 1");

	return 0;
}
